package com.xylink.sdk.test;

import com.xylink.config.SDKConfigMgr;
import com.xylink.model.*;
import com.xylink.sdk.distributor.DistributorApi;
import com.xylink.util.RandomValue;
import com.xylink.util.Result;
import org.junit.BeforeClass;
import org.junit.Test;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import static org.junit.Assert.fail;

/**
 * Created with IntelliJ IDEA.
 * Description:
 * User: gzm
 * Date: 2019-04-26
 */
public class DistributorTest {

//    txdev
    private String distributorid = "91f6f4e6f668b83edff4d80db9c44217b7dd4b70";
    private String enterpriseid = "2c91e8fa60da91720160da92ce140000";
    private String token = "cb8d4881a2fab5da4a9fd46b9939fd4629c83104580451b611de203add3d8548";

    //pre
//    private String distributorid = "c27efa2adc3c2998bf8f517a1155559803b6c4e9";
//    private String enterpriseid = "ff808081692fd501016937239f7e0147";
//    private String token = "70cf5ced8a5e34f6a48096952dd563d7d0fd36f7ab59a4d0028600f8c2617560";

//    //prd
//    private String distributorid = "d8df78de6c12b83b56e49946ed8ad780b77bdf6d";
//    private String enterpriseid = "ff8080816b2ddf39016b2e9aabed0057";
//    private String token = "c144d6dce470e90981feadb0078037ac4588eb3164de53059448383f9c2f0402";

    @BeforeClass
    public static void setup() {
        SDKConfigMgr.setServerHost("https://dev.xylink.com");
//        SDKConfigMgr.setServerHost("http://127.0.0.1:8085");
//        SDKConfigMgr.setServerHost("http://172.18.160.71:8080");//pre
//        SDKConfigMgr.setServerHost("http://172.20.58.196:8080");//prd
//        SDKConfigMgr.setServerHost("https://sdk.xylink.com");//prd
    }

    @Test
    public void addEnterprise() {
        DistributorApi distributorApi = new DistributorApi();
        try {
            Result result = distributorApi.addEnterprise(distributorid, token,
                    RandomValue.getBuffetAddEnterpriseReq());
            System.out.println("responds:" + result.getData().toString());
        } catch (IOException e) {
            fail(e.getMessage());
        }
    }

    @Test
    public void modifyEnterprise() {
        DistributorApi distributorApi = new DistributorApi();
        BuffetAddEnterpriseReq buffetAddEnterpriseReq = new BuffetAddEnterpriseReq();
        buffetAddEnterpriseReq.setAdminName("adminName1");
        buffetAddEnterpriseReq.setCity("长安");
        buffetAddEnterpriseReq.setContactNumber("contactname1");
        buffetAddEnterpriseReq.setCountry("中国");
        buffetAddEnterpriseReq.setCountryCode("86");
        buffetAddEnterpriseReq.setDetailAddress("长安街");
        buffetAddEnterpriseReq.setProvince("南京市");
        buffetAddEnterpriseReq.setDistrict("---");
        buffetAddEnterpriseReq.setIndustry("01");
        buffetAddEnterpriseReq.setMailbox(RandomValue.getEmail(3,7));
        buffetAddEnterpriseReq.setName(RandomValue.getChineseName());
        buffetAddEnterpriseReq.setPhone(RandomValue.getTel());
        buffetAddEnterpriseReq.setPhoneCountryCode("+86");
        try {
            Result result = distributorApi.modifyEnterprise(distributorid,enterpriseid, token,
                    buffetAddEnterpriseReq);
            System.out.println("responds:" + result.getData().toString());
        } catch (IOException e) {
            fail(e.getMessage());
        }
    }


    @Test
    public void getEnterprises() {
        DistributorApi distributorApi = new DistributorApi();
        try {
            Result result = distributorApi.getEnterprises(distributorid, token,
                    0,20);
            System.out.println("responds:" + result.getData().toString());
        } catch (IOException e) {
            fail(e.getMessage());
        }
    }

    @Test
    public void batchUsers() {
        DistributorApi distributorApi = new DistributorApi();
        List<EnterpriseUserReq> enterpriseUserReqs = new ArrayList<EnterpriseUserReq>();
        for (int i=0;i<1;i++){
            enterpriseUserReqs.add(RandomValue.getEnterpriseUserReq(enterpriseid));
        }
        try {
            Result result = distributorApi.batchEnterpriseUsers(distributorid, token, enterpriseUserReqs);
            System.out.println("responds:" + result.getData().toString());
        } catch (IOException e) {
            fail(e.getMessage());
        }
    }

    @Test
    public void modifyUsers() {
        DistributorApi distributorApi = new DistributorApi();
        String userProfileId = "23324503";
        UserReq user = new UserReq(enterpriseid,userProfileId,"mdifyname2");
        try {
            Result result = distributorApi.modifyUser(distributorid, token, user);
            System.out.println("responds:" + result.getData().toString());
        } catch (IOException e) {
            fail(e.getMessage());
        }
    }

    @Test
    public void getUsers() {
        DistributorApi distributorApi = new DistributorApi();
        try {
            Result result = distributorApi.getUsers(distributorid, token,enterpriseid,0,20);
            System.out.println("responds:" + result.getData().toString());
        } catch (IOException e) {
            fail(e.getMessage());
        }
    }

    @Test
    public void getUserByUserId() {
        DistributorApi distributorApi = new DistributorApi();
        String userProfileId = "23324503";
        try {
            Result result = distributorApi.getUserByUserId(distributorid, token,userProfileId);
            System.out.println("responds:" + result.getData().toString());
        } catch (IOException e) {
            fail(e.getMessage());
        }
    }

    @Test
    public void deleteUserByUserId() {
        DistributorApi distributorApi = new DistributorApi();
        String userProfileId = "23324503";
        try {
            Result result = distributorApi.deleteUserByUserId(distributorid, token,userProfileId);
            System.out.println("responds:" + result.getData().toString());
        } catch (IOException e) {
            fail(e.getMessage());
        }
    }

    //===================//

    @Test
    public void getNemosPage() {
        DistributorApi distributorApi = new DistributorApi();
        try {
            Result result = distributorApi.getNemosPage(distributorid, token,enterpriseid,false,0,10);
            System.out.println("responds:" + result.getData().toString());
        } catch (IOException e) {
            fail(e.getMessage());
        }
    }

    @Test
    public void getDevicesInfoPage() {
        DistributorApi distributorApi = new DistributorApi();
        try {
            Result result = distributorApi.getDevicesInfoPage(distributorid, token,enterpriseid,0,10);
            System.out.println("responds:" + result.getData().toString());
        } catch (IOException e) {
            fail(e.getMessage());
        }
    }

    @Test
    public void editDevice() {
        DistributorApi distributorApi = new DistributorApi();
        try {
            Result result = distributorApi.editDevice(distributorid, token,enterpriseid,"607537","测试修改name6");
//            System.out.println("responds:" + result.getData().toString());
        } catch (IOException e) {
            fail(e.getMessage());
        }
    }

    @Test
    public void addDevice() {
        DistributorApi distributorApi = new DistributorApi();
        List<UserDeviceDto> userDeviceDtos =  new ArrayList<UserDeviceDto>();
        UserDeviceDto userDeviceDto = new UserDeviceDto();
        userDeviceDto.setEnterpriseId(enterpriseid);
        userDeviceDto.setDisplayName("测试添加通讯录");
        userDeviceDto.setNemoNumber("607537");
        userDeviceDtos.add(userDeviceDto);
        try {
            Result result = distributorApi.addDevice(distributorid, token,enterpriseid,userDeviceDtos);
            System.out.println("responds:" + result.getData().toString());
        } catch (IOException e) {
            fail(e.getMessage());
        }
    }

    @Test
    public void removeDevice() {
        DistributorApi distributorApi = new DistributorApi();
        try {
            Result result = distributorApi.removeDevice(distributorid, token,enterpriseid,"941242");
//            System.out.println("responds:" + result.getData().toString());
        } catch (IOException e) {
            fail(e.getMessage());
        }
    }

    @Test
    public void getNemoMeetingPage() {
        DistributorApi distributorApi = new DistributorApi();
        try {
            Result result = distributorApi.getNemoMeetingPage(distributorid, token,enterpriseid,"471207",1562307148l,System.currentTimeMillis(),0,10);
            System.out.println("responds:" + result.getData().toString());
        } catch (IOException e) {
            fail(e.getMessage());
        }
    }

    @Test
    public void getConferenceCurrentMeetingPage() {
        DistributorApi distributorApi = new DistributorApi();
        try {
            Result result = distributorApi.getConferenceCurrentMeetingPage(distributorid, token,enterpriseid,"910087475352",0,10);
            System.out.println("responds:" + result.getData().toString());
        } catch (IOException e) {
            fail(e.getMessage());
        }
    }

    @Test
    public void getEnterpriseCurrentMeetingPage() {
        DistributorApi distributorApi = new DistributorApi();
        try {
            Result result = distributorApi.getEnterpriseCurrentMeetingPage(distributorid, token,enterpriseid,0,10);
            System.out.println("responds:" + result.getData().toString());
        } catch (IOException e) {
            fail(e.getMessage());
        }
    }

    @Test
    public void addUserAdmin() {
        DistributorApi distributorApi = new DistributorApi();
        UserAdminReq userAdminReq = new UserAdminReq(enterpriseid,"18866674211");
        System.out.println("addUserAdmin:"+userAdminReq);
        try {
            Result result = distributorApi.addUserAdmin(distributorid, token,userAdminReq);
            System.out.println("responds:" + result.getData().toString());
        } catch (IOException e) {
            fail(e.getMessage());
        }
    }

    @Test
    public void updateUserAdmin() {
        DistributorApi distributorApi = new DistributorApi();
        UserAdminReq userAdminReq = new UserAdminReq(enterpriseid,"13601472054");
        try {
            Result result = distributorApi.updateUserAdmin(distributorid, token,userAdminReq);
            System.out.println("responds:" + result.getData().toString());
        } catch (IOException e) {
            fail(e.getMessage());
        }
    }

    @Test
    public void deleteUserAdmin() {
        DistributorApi distributorApi = new DistributorApi();
        UserAdminReq userAdminReq = new UserAdminReq(enterpriseid,"13601472054");
        userAdminReq.setPhone("");
        try {
            Result result = distributorApi.deleteUserAdmin(distributorid, token,userAdminReq);
            System.out.println("responds:" + result.getData().toString());
        } catch (IOException e) {
            fail(e.getMessage());
        }
    }
}
