package com.xylink.sdk.test;

import com.xylink.config.SDKConfigMgr;
import com.xylink.model.Pager;
import com.xylink.model.ReminderMeeting;
import com.xylink.sdk.conferenceControl.CloudMeetingRoomApi;
import com.xylink.sdk.dating.ScheduleMeetingApi;
import com.xylink.util.Result;
import com.xylink.util.SignatureSample;
import org.junit.BeforeClass;
import org.junit.Test;

import java.io.IOException;
import java.util.Set;
import java.util.TreeSet;

import static org.junit.Assert.fail;

/**
 * Created by changxiangyang on 2017/9/19.
 */
public class ScheduleMeetingTest {
    private String enterpriseid=TestConfig.getInstance().getEnterpriseId();
    private String token = TestConfig.getInstance().getToken();
    private String meetingId = "";
    private String meetingRoomNumber = "";
    private static SignatureSample signatureSample = new SignatureSample();

    @BeforeClass
    public static void setup() {
//        SDKConfigMgr.setServerHost("https://sdk.xylink.com");
//        SDKConfigMgr.setServerHost("http://127.0.0.1:8081");
        SDKConfigMgr.setServerHost("https://sdk.xylink.com");
    }

    //预约会议
    @Test
    public void remindMeeting(){
        enterpriseid = "f3c422a7c36eac6c924ed2a50eb4f49f82b128de";
        token = "a727338bb95fb608dde30774a96ae712c4a71ab3a4d6b499282048852bfe5a43";
        Set<String> ps = new TreeSet<String>();
        Set<String> sps = new TreeSet<String>();
//        ps.add("23869749");
//        ps.add("846240");
//        ps.add("12346068753");
//        ps.add("13811083892");

//        sps.add("846240");
        ScheduleMeetingApi sma=new ScheduleMeetingApi();
        ReminderMeeting reminderMeeting=new ReminderMeeting();
        reminderMeeting.setTitle("testtesttest");
        reminderMeeting.setStartTime(System.currentTimeMillis() + (1000 * 60 * 1));
        reminderMeeting.setEndTime(System.currentTimeMillis() + (1000 * 60 * 60));
        reminderMeeting.setAddress("地中海");
        reminderMeeting.setAutoInvite(1);
        reminderMeeting.setPassword("0000");
        reminderMeeting.setMeetingRoomType(1);
        reminderMeeting.setAutoRecord(0);
        reminderMeeting.setParticipants(ps);
        reminderMeeting.setSingleRecordParticipants(sps);
        reminderMeeting.setConferenceNumber("9000637037");
        try {
            Result result = sma.remindMeeting(enterpriseid, token, reminderMeeting);
            System.out.println(result);
            //如成功后的一个示例：{"success":true,"errorStatus":200,"data":{"meetingId":"ff80808165a02ba20165cc92ef9b542c","meetingRoomNumber":"956401821"}}
        }catch (IOException e){
            System.out.println("testRemindMeeting--"+e);
        }
    }
    //修改预约会议 TODO 会议id和会议号必须是合法的，可以通过remindMeeting()方法先预约会议
    @Test
    public void updateMeeting(){
        meetingId = "ff8080816bb7d2eb016bb7e9796d000d";
        meetingRoomNumber = "9797";

        enterpriseid = "40260e9046bae2da238ac0b0c572326b91726a83";
        token = "91c648e1df1bfa9d9c879c408d7583dfb7c353cadf8e15ad64031fe9a8cde098";
        Set<String> ps = new TreeSet<String>();
        Set<String> sps = new TreeSet<String>();
        ps.add("23869749");
        ps.add("23896157");
        ps.add("13810090687");
        ps.add("13811083892");

        sps.add("10837801");
        sps.add("13811083892");

        ScheduleMeetingApi sma=new ScheduleMeetingApi();
        ReminderMeeting reminderMeeting=new ReminderMeeting();
        reminderMeeting.setTitle("预约会议update");
        reminderMeeting.setStartTime(System.currentTimeMillis() + (1000 * 60 * 4));
        reminderMeeting.setEndTime(System.currentTimeMillis() + (1000 * 60 * 6));
        reminderMeeting.setConferenceNumber(meetingRoomNumber);
        reminderMeeting.setAddress("地中海");
        reminderMeeting.setAutoInvite(1);
        reminderMeeting.setPassword("2345");
        reminderMeeting.setAutoRecord(0);
        reminderMeeting.setSingleRecordParticipants(sps);
        reminderMeeting.setParticipants(ps);

        try {
            Result result = sma.updateMeeting(enterpriseid, token, meetingId, reminderMeeting);
            System.out.println(result);
        }catch (IOException e){
            System.out.println("testEnd--"+e);
        }
    }

    //删除会议 TODO 会议id必须有效
    @Test
    public void deleteMeeting(){
        ScheduleMeetingApi sma=new ScheduleMeetingApi();
        String meetingId = "ff80808165a02ba20165cc92ef9b542c";
        try {
            Result result = sma.deleteMeeting(enterpriseid, token, meetingId);
            System.out.println(result);
        }catch (IOException e){
            System.out.println("testEnd--"+e);
        }
    }
    //按照结束时间获取会议
    @Test
    public void getAllMeeting(){
        ScheduleMeetingApi sma=new ScheduleMeetingApi();
        enterpriseid = "40260e9046bae2da238ac0b0c572326b91726a83";
        token = "91c648e1df1bfa9d9c879c408d7583dfb7c353cadf8e15ad64031fe9a8cde098";
        long endtime = 0;
        try {
            Result<ReminderMeeting[]> allMeeting = sma.getAllMeeting(enterpriseid, token, endtime);
            System.out.println(allMeeting);
        }catch (IOException e){
            System.out.println("testEnd--"+e);
        }
    }

    @Test
    public void getMeetingByPage() {
        ScheduleMeetingApi scheduleMeetingApi = new ScheduleMeetingApi();
        enterpriseid = "40260e9046bae2da238ac0b0c572326b91726a83";
        token = "91c648e1df1bfa9d9c879c408d7583dfb7c353cadf8e15ad64031fe9a8cde098";
        int page = 0;
        int size = 50;
        long endTime = 0;
        Result<Pager<ReminderMeeting>> result;

        try {
            result = scheduleMeetingApi.getMeeting(enterpriseid, token, page, size, endTime);
            System.out.println(result);
        } catch (IOException e) {
            System.out.println(e);
        }
    }

    @Test
    public void getMeetingByNumberPage() {
        ScheduleMeetingApi scheduleMeetingApi = new ScheduleMeetingApi();
        enterpriseid = "40260e9046bae2da238ac0b0c572326b91726a83";
        token = "91c648e1df1bfa9d9c879c408d7583dfb7c353cadf8e15ad64031fe9a8cde098";
        int page = 0;
        int size = 50;
        Result<Pager> result;
        try {
            result = scheduleMeetingApi.getMeetingByConfrenceNumber(enterpriseid, token, page, size, "9797");
            System.out.println(result);
        } catch (IOException e) {
            System.out.println(e);
        }
    }

    @Test
    public void getCurlUrl() {
        String url = "https://sdk.xylink.com/api/rest/external/v1/miniprogram/users?enterpriseId=e37e572656f476b774142587b27fbd7c37776714&appId=BHNNNNVNNVVDT";
        token = "99a66e7da4fe183f5049ef892358471ebeb5598eb2987d61276a25512867fab7";
        String curlUrl = url + "&signature="+signatureSample.computeSignature("", "GET", token, url);
        System.out.println("curlUrl:"+curlUrl);
    }
}
